> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/bmc/bare-metal-instance/describeinstanceipmiurl.md).

# DescribeInstanceIpmiUrl

## 1. API Description

This API (DescribeInstanceIpmiUrl) is used to query the IPMI console access URL of a bare metal instance.

{% hint style="info" %}
**Notes**

* Before calling this API, you need to set the IPMI password via [ResetInstanceIpmiPassword](/api-reference/bmc/bare-metal-instance/resetinstanceipmipassword.md). Otherwise, OPERATION\_DENIED\_INSTANCE\_IPMI\_NOT\_ENABLED will be returned.
* After opening the console URL, log in with the username `operator` and the password set via [ResetInstanceIpmiPassword](/api-reference/bmc/bare-metal-instance/resetinstanceipmipassword.md).
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description  |
| -------------- | -------- | ------ | ------------ |
| instanceId     | Yes      | String | Instance ID. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                                                                                                                                     |
| -------------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p>                                                                                                           |
| url            | String | <p>IPMI console access URL.</p><p>The login username is fixed as operator, and the password is the one set via <a href="/api-reference/bmc/bare-metal-instance/resetinstanceipmipassword.md">ResetInstanceIpmiPassword</a>.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Obtain the IPMI console URL of an instance.**

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeInstanceIpmiUrl
<Common Request Params>

Request:
{
  "instanceId": "1234567890123456789"
}

Response:
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "url": "https://xxx.zenlayer.net/console/xxxx"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                          | Description                                                                                                                                                                                   |
| ---------------- | --------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                       | Instance does not exist.                                                                                                                                                                      |
| 403              | OPERATION\_DENIED\_INSTANCE\_RECYCLED               | The instance is in the recycle bin.                                                                                                                                                           |
| 409              | OPERATION\_DENIED\_INSTANCE\_IPMI\_NOT\_ENABLED     | The IPMI console of the instance is not enabled. Please call [ResetInstanceIpmiPassword](/api-reference/bmc/bare-metal-instance/resetinstanceipmipassword.md) to set the IPMI password first. |
| 409              | OPERATION\_FAILED\_INSTANCE\_IPMI\_URL\_UNAVAILABLE | Failed to obtain the IPMI console URL of the instance.                                                                                                                                        |
